/******************************************************************/
/* filename: tools.c */
/* version : 1.00  */
/* author  : Jan Feenstra */
/******************************************************************/

#include <strings.h>
#include "cp.h"
#include "debug.h"
/******************************************************************/

int decodeTitle(char ut1[USERTITLELENGTH], char ut2[USERTITLELENGTH+1]);
int encodeTitle(char ut1[USERTITLELENGTH+1], char ut2[USERTITLELENGTH]);
int writeTitle(char ut1[USERTITLELENGTH]);
int decodeConfid(char ut1[CONFIDLENGTH], char ut2[CONFIDLENGTH+1]);
int encodeConfid( char ut1[CONFIDLENGTH+1], char ut2[CONFIDLENGTH]);
int writeConfid(char ut1[CONFIDLENGTH]);
int decodeData(char len, char data1[DATALENGTH], char data2[DATALENGTH+1]);
int encodeData(char data1[DATALENGTH+1], char *len, char data2[DATALENGTH]);
int writeData(const char data[DATALENGTH]);
/******************************************************************/

int decodeTitle(char ut1[USERTITLELENGTH], char ut2[USERTITLELENGTH+1])
{
 int i,j;

 for (i=0; i<USERTITLELENGTH; i++)
  if (ut1[i]!='\0') break;
 if (i!=USERTITLELENGTH)
 {
  for (j=0;i<USERTITLELENGTH;i++,j++)
   ut2[j] = ut1[i];
 }
 ut2[j] = '\0';
 return 0;
}
/******************************************************************/

int encodeTitle(char ut1[USERTITLELENGTH+1], char ut2[USERTITLELENGTH])
{
 int i,j;

 i=strlen(ut1);
 if ( (0<=i) && (i<=USERTITLELENGTH) )
 {
  i=USERTITLELENGTH-i;
  for (j=0; j<i; j++)
	ut2[j] = '\0';
  for (i=0; j<USERTITLELENGTH; j++, i++)
	ut2[j] = ut1[i];
  return(0);
 }
 else
 {
  Error(Dbg,"The encoding title string is to long...");
  return(-1);
 }
}
/******************************************************************/

int writeTitle(char ut1[USERTITLELENGTH])
{char buf[USERTITLELENGTH+1];
 int i;
 for (i=0; i<USERTITLELENGTH; i++)
  if (ut1[i]<=32) buf[i] = '_';
  else buf[i] = ut1[i];
 buf[i+1] = '\0'; 
 Debug(Dbg,"<%s>\n",buf);
}
/******************************************************************/

int decodeConfid(char ut1[CONFIDLENGTH], char ut2[CONFIDLENGTH+1])
{
 int i,j;

 for (i=0; i<CONFIDLENGTH; i++)
  if (ut1[i]!='\0') break;
 if (i!=CONFIDLENGTH)
 {
  for (j=0;i<CONFIDLENGTH;i++,j++)
   ut2[j] = ut1[i];
 }
 ut2[j] = '\0';
 return 0;
}
/******************************************************************/

int encodeConfid( char ut1[CONFIDLENGTH+1], char ut2[CONFIDLENGTH])
{
 int i,j;
  
 i=strlen(ut1);
 if ( (0<=i) && (i<=CONFIDLENGTH) )
 {
  i=CONFIDLENGTH-i; 
  for (j=0; j<i; j++)
   ut2[j] = '\0';
  for (i=0; j<CONFIDLENGTH; j++, i++)
   ut2[j] = ut1[i];
  return(0);
 }
 else
 {
  Error(Dbg,"The encoding confid string is to long...");
  return(-1);
 }
}
/******************************************************************/

int writeConfid(char ut1[CONFIDLENGTH])
{char buf[CONFIDLENGTH+1];
 int i;
 for (i=0; i<CONFIDLENGTH; i++)
  if (ut1[i]<=32) buf[i] = '_';
  else buf[i] = ut1[i];
 buf[i+1] = '\0'; 
 Debug(Dbg,"<%s>\n",buf);
}
/******************************************************************/

int decodeData(char len, char data1[DATALENGTH], char data2[DATALENGTH+1])
{
 int i;
 for (i=0; i<len; i++)
  data2[i] = data1[i];
 data2[i]='\0';
 return(0);
}
/******************************************************************/

int encodeData(char data1[DATALENGTH+1], char *len, char data2[DATALENGTH])
{
 int i;
 for (i=0 ; (data1[i]!='\0') && (i<DATALENGTH) ; i++) 
  data2[i]=data1[i];
 *len = i;
 return(0);
}
/******************************************************************/

int writeData(const char data[DATALENGTH])
{char buf[DATALENGTH+1];
 int i;
 for (i=0; i<CONFIDLENGTH; i++)
  if (data[i]<=32) buf[i] = '_';
  else buf[i] = data[i];
 buf[i+1] = '\0'; 
 Debug(Dbg,"<%s>\n",buf);
}
/******************************************************************/



