/******************************************************************/
/* filename: udp.c */
/* version : 1.00  */
/* author  : Jan Feenstra */
/******************************************************************/

#include <sys/socket.h>
#include "cp.h"
#include "cfpe.h"
#include "processConfig.h"

/******************************************************************/
/* function prototying (forward declaration) */

int USAP_datareq_proc(
 const int usap,
 const struct sockaddr_in *dstAddr, 
 const char *pdu, 
 const int maxpdusize);

int USAP_dataind_proc(
 const int usap, 
 struct sockaddr_in *srcAddr,
 char *pdu, 
 const int maxpdusize, 
 int *pdusize);

/******************************************************************/
/* below implementation of functions */
/******************************************************************/

int 
USAP_datareq_proc
( 
const int usap, 
const struct sockaddr_in *dstAddr, 
const char *pdu, 
const int maxpdusize
)
{
 if(sendto(usap, pdu, maxpdusize, 0, \
   (struct sockaddr *)dstAddr, sizeof(struct sockaddr_in)) < 0)
  return (-1);
 return(0);
}
/******************************************************************/

int 
USAP_dataind_proc
(
 const int usap, 
 struct sockaddr_in *srcAddr,
 char *pdu, 
 const int maxpdusize, 
 int *pdusize
)
{
 unsigned int size;

 size = sizeof(struct sockaddr_in);
 if (((*pdusize) = recvfrom(usap, (char *)pdu , maxpdusize, 0, \
   (struct sockaddr *)srcAddr, &size)) < 0)
  return(-1);
 return(0);
}
/******************************************************************/

